<!--HAS_WEBDNA_TAGS-->
[!] Lookup the value of the 'read date format' setting [/!]
[showif =[sandboxid]][text]_db=WebCatalog Prefs[/text][/showif]
[hideif =[sandboxid]][text]_db=SandBoxPrefs[/text][/hideif]
[text]date_format=[lookup db=[_db]&lookinfield=preference&value=ReadDateFormat&returnfield=value&notfound=mdy][/text]

[!]setup arrays for weekday and weekofmonth and months[/!]
[!]day of week[/!]
[arrayset name=DOW&dim=8](1)=Sunday&(2)=Monday&(3)=Tuesday&(4)=Wednesday&(5)=Thursday&(6)=Friday&(7)=Saturday&(8)=DayOfMonth[/arrayset]
[!]week of month[/!]
[arrayset name=WOM&dim=5](1)=First&(2)=Second&(3)=Third&(4)=Fourth&(5)=Last[/arrayset]
[arrayset name=MONTHS&dim=12](1)=January&(2)=February&(3)=March&(4)=April&(5)=May&(6)=June&(7)=July&(8)=August&(9)=September&(10)=October&(11)=November&(12)=December[/arrayset]

[function name=getWeekInMonthForDate]
[!]-- input args: theDate --[/!]
[!]-- EXAMPLE call: [getWeekInMonthForDate theDate=3/17/2004] (this particular call will return 3) --[/!]
	[math show=f]julianDate={[theDate]}[/math]
	[text]dayNumber=[format days_to_date %d][julianDate][/format][/text]
	[!][dayNumber][/!]
	[text]dayOfWeek=[format days_to_date %w][julianDate][/format][/text]
	[!][dayOfWeek][/!]
	[math show=f]weekNum=ceil(([dayNumber]-[dayOfWeek])/7)+1[/text][/math]
	[!][weekNum][/!]
	[return][weekNum][/return]
[/function]

[function name=getDayCount]
[!]-- input args: month, year --[/!]
[!]-- EXAMPLE call: [getDayCount month=3&year=2004] (this particular call will return 31) --[/!]
	[text]month=[/text]
	[text]year=[/text]
	[math show=f]nextMonth=[showif [month]=12]1[/showif][hideif [month]=12][month]+1[/hideif][/math]
	[!]]nextMonth: [nextMonth][/!]
	[math show=f]_year=[showif [month]=12][year]+1[/showif][hideif [month]=12][year][/hideif][/math]
	[!]_year: [_year][/!]
	[if "[date_format]"="mdy"][then]
		[math date&show=f]lastDate={[nextMonth]/1/[_year]}-1[/math]
	[/then]
	[else]
		[math date&show=f]lastDate={1/[nextMonth]/[_year]}-1[/math]
	[/else]
	[/if]
	[!]lastDate: [math date][lastDate][/math][/!]
	[if "[date_format]"="mdy"][then]
		[math date&show=f]dayCount=[lastDate]-{[month]/1/[year]}+1[/math]
	[/then]
	[else]
		[math date&show=f]dayCount=[lastDate]-{1/[month]/[year]}+1[/math]
	[/else]
	[/if]
	[return][dayCount][/return]
[/function]

[function name=getWeekCount]
[!]-- input args: month, year --[/!]
[!]-- EXAMPLE call: [getWeekCount month=5&year=2004] (this particular call will return 6) --[/!]
	[text]month=[/text]
	[text]year=[/text]
	[if "[date_format]"="mdy"][then]
		[text]thisDate=[month]/[getDayCount month=[month]&year=[year]]/[year]
	[/then]
	[else]
		[text]thisDate=[getDayCount month=[month]&year=[year]]/[month]/[year]
	[/else]
	[/if]
	[return][getWeekInMonthForDate theDate=[thisDate]][/return]
[/function]

[function name=getDayOccurrenceDate]
[!]-- input args: month, year, ordinal, day; ordinal is the week in which you want "day" to occur and "day" can have values 0=Sunday, 1=Monday, ..., 6=Saturday --[/!]
[!]-- EXAMPLE call: [math date][getDayOccurrenceDate month=3&year=2004&ordinal=5&day=3][/math] (this particular call will return 03/31/2004) --[/!]
[!]-- NOTE!  This function does not check ordinal/week boundaries; i.e if you set ordinal to 6 and the month only has 5 weeks, the function will return the next date in sequence... the one in the month following! --[/!]
[!]	     (changed to get the last occurence in the month by passing in 5 for the ordinal, if there were not 5 then it gets the last one now)[/!]
	[text]month=[/text]
	[text]year=[/text]
	[text]ordinal=[/text]	[!]-- equivalent to the week in which you want the day to occur --[/!]
	[text]day=[/text]			[!]-- 0=Sunday, 1=Monday, ..., 6=Saturday --[/!]	
	
	[if "[date_format]"="mdy"][then]
		[text]firstDate=[month]/1/[year][/text]
	[/then]
	[else]
		[text]firstDate=1/[month]/[year][/text]
	[/else]
	[/if]
	[!]firstDate: [firstDate]<br>[/!]
	[text]day1=[format days_to_date %w][math]{[firstDate]}[/math][/format][/text]
	[!]day1: [day1]<br>[/!]
	[math show=f]dayOffset=[day]-[day1][/math]	[!]-- NOTE: if dayOffset<0 we know that it cannot be in the first week --[/!]
	[!]dayOffset: [dayOffset]<br>[/!]
	[math show=f]weekOffset=[showif [dayOffset]<0][ordinal][/showif][hideif [dayOffset]<0][ordinal]-1[/hideif][/math]
	[!]weekOffset: [weekOffset]<br>[/!]
	[math date&show=f]baseDate={[firstDate]}+[dayOffset][/math]
	[!]baseDate: [math date][baseDate][/math]<br>[/!]
	[math show=f]dayAdjustment=7*[weekOffset][/math]
	[!]dayAdjustment: [dayAdjustment]<br>[/!]
	[math date&show=f]targetDate=[baseDate]+[dayAdjustment][/math]
	
	[!]if the month is the next month then subtract 1 week[/!]
	[showif [format days_to_date %m][targetDate][/format]![month]]
		[math show=f]targetDate=[targetdate]-7[/math]
	[/showif]
	[!]targetDate: [math date][targetDate][/math][/!]
	[return][targetDate][/return]
[/function]

[function name=getDayOfWeekFromWeekday]
[!]input:weekday (full weekday name) returns numeric day of the week[/!]
	[text]day=[/text]
	[showif [weekday]=Sunday][text]day=0[/text][/showif]
	[showif [weekday]=Monday][text]day=1[/text][/showif]
	[showif [weekday]=Tuesday][text]day=2[/text][/showif]
	[showif [weekday]=Wednesday][text]day=3[/text][/showif]
	[showif [weekday]=Thursday][text]day=4[/text][/showif]
	[showif [weekday]=Friday][text]day=5[/text][/showif]
	[showif [weekday]=Saturday][text]day=6[/text][/showif]
	[return][day][/return]
[/function]

[function name=getMonthNumber]
[!]input:monthname (full month name) returns numeric month of the year 1-12[/!]
	[text]monthNumber=[/text]
	
	[loop start=1&end=12]
		[showif [months([index])]=[monthname]][text]monthNumber=[index][/text][index][/showif]
	[/loop]
	[return][monthNumber][/return]
[/function]

[function name=getEndDate]
[!]-- input args: startdate,occurences, recurrenceString[/!]
	recurrenceString:[recurrenceString]<br>
	[showif [recurrenceString]^daily]
		[text]myEndDate=[Math]{[StartDate]}+[occurences]-1[/Math][/text]
	[/showif]
	[!]------------------------weekly--------------------------------------[/!]	
	[!]weekly_Tuesday_Thursday[/!]
	[showif [recurrenceString]^weekly]
		[text]thisStartDate=[startdate][/text]
		[math show=f]firstWeekOffset=0[/math]
		[text]startWeekday=[format days_to_date %w][math]{[startdate]}[/math][/format][/text]
		[!]get each weekday and keep the number of days selected and the lastweekday selected[/!]
		[ListWords Words=[middle startafter=weekly_][recurrenceString][/middle]&Delimiters=_]
			[showif [getDayOfWeekFromWeekday weekday=[word]]<[startWeekday]]
				[math show=f]firstWeekOffset=[firstWeekOffset]+1[/math]
			[/showif]
			[text]lastWeekday=[word][/text]
			[text]NumberOfDays=[index][/text]
		[/ListWords] 
		
		
		[!]find the number of full weeks to add[/!]
		[math show=f]weeks=floor([occurences]/[numberOfDays])[/math]
		startWeekday:[startWeekday] firstWeekOffset:[firstWeekOffset] weeks:[weeks]-[math]ceil([occurences]/[numberOfDays])[/math]<br>
		
		[!]if we need to add a partial week then set the start date to match up with the last weekday 
		needed to get the number of occurences, we can then add the weeks to that[/!]
		[if ("[weeks]"!"[math]ceil([occurences]/[numberOfDays])[/math]")|("[firstWeekOffset]"!"0")][then]
			[ListWords Words=[middle startafter=weekly_][recurrenceString][/middle]&Delimiters=_]
				[showif [math]([weeks]*[numberOfDays])-[firstWeekOffset]+[index][/math]=[occurences]]	
					[text]lastweekday=[word][/text]
				[/showif]
			[/ListWords]
			[!]add a week for this partial week[/!]
			[math show=f]weeks=[weeks]+1[/math]
		[/then]
		[/if]
		
		[!]daystoadd:[getDayOfWeekFromWeekday weekday=[lastweekday]] -[format Days_To_Date %w][math]{[startdate]}[/math][/format]=[math][getDayOfWeekFromWeekday weekday=[lastweekday]]-[format Days_To_Date %w][math]{[startdate]}[/math][/format][/math]<br>[/!]
		[text]thisStartDate=[math date]{[startDate]}+([getDayOfWeekFromWeekday weekday=[lastweekday]]-[format Days_To_Date %w][math]{[startdate]}[/math][/format])[/math][/text]
		[!]thisStartDate:[thisStartDate][/!]
		
		[!]add the number of weeks to either the original startdate or the number of days after the start date needed to reach the occurences[/!]
		[if "[date_format]"="mdy"][then]
			[text]myEndDate=[Math]{[thisStartDate]}+{00/[math]([weeks]-1)*7[/math]/0000}[/Math][/text]
		[/then]
		[else]
			[text]myEndDate=[Math]{[thisStartDate]}+[math]([weeks]-1)*7[/math][/Math][/text]
		[/else]
		[/if]
		myEndDate=[format Days_To_Date][myEndDate][/format]<br>
	[/showif]
	[!]------------------------monthly--------------------------------------[/!]	
	[!]monthly_date_15[/!]
	[showif [recurrenceString]^monthly_date]
		[text]myDay=[middle startafter=monthly_date_][recurrenceString][/middle][/text]
		[text]myMonth=[format Days_To_Date %m][math]{[startdate]}[/math][/format][/text]
		[text]myYear=[format Days_To_Date %Y][math]{[startdate]}[/math][/format][/text]

		[if "[date_format]"="mdy"][then]
			[text]myStartDate=[myMonth]/[myDay]/[myYear][/text]
		[/then]
		[else]
			[text]myStartDate=[myDay]/[myMonth]/[myYear][/text]
		[/else]
		[/if]
		myStartDate:[myStartDate] <br>
		[if "[date_format]"="mdy"][then]
			[text]myEndDate=[Math]{[myStartDate]}+{[math][occurences]-1[/math]/00/0000}[/Math][/text]
		[/then]
		[else]
			[text]myEndDate=[Math]{[myStartDate]}+{00/[math][occurences]-1[/math]/0000}[/Math][/text]
		[/else]
		[/if]
		
		myEndDate=[format Days_To_Date][myEndDate][/format]

	[/showif]
			
	[!]monthly_day_4_Monday[/!]
	[showif [recurrenceString]^monthly_day]
		
		[text]myMonth=[format Days_To_Date %m][math]{[startdate]}[/math][/format][/text]
		[text]myYear=[format Days_To_Date %Y][math]{[startdate]}[/math][/format][/text]
		[text]myOrdinal=[middle startafter=monthly_day_&endbefore=_][recurrenceString][/middle][/text]
		[text]myWeekday=[getchars start=15][recurrenceString][/getchars][/text]
		[text]myWeekdayNumber=[getDayOfWeekFromWeekday weekday=[myWeekdayName]][/text]
		
		[!]month=[myMonth]&year=[myYear]&ordinal=[myOrdinal]&day=[myWeekday]<br>[/!]
		[!]any weekday of the month based only on the ordinal[/!]
		[showif [myWeekday]=DayOfMonth]
			[if "[date_format]"="mdy"][then]
				[text]myStartDate=[myMonth]/[showif [myOrdinal]=5][getDayCount month=[myMonth]&year=[myyear]][/showif][showif [myOrdinal]!5][myOrdinal][/showif]/[myYear][/text]
			[/then]
			[else]
				[text]myStartDate=[showif [myOrdinal]=5][getDayCount month=[myMonth]&year=[myyear]][/showif][showif [myOrdinal]!5][myOrdinal][/showif]/[myMonth]/[myYear][/text]
			[/else]
			[/if]
		[/showif]
		[!]regular weekday[/!]
		[showif [myWeekday]!DayOfMonth]
			[text]myStartDate=[format Days_To_Date][getDayOccurrenceDate month=[myMonth]&year=[myYear]&ordinal=[myOrdinal]&day=[myWeekdayNumber]][/format][/text]
		[/showif]
		[!]myStartDate:[myStartDate]<br>[/!]
		[!]get the month and year of our last occurence[/!]
		[if "[date_format]"="mdy"][then]
			[text]myEndDate=[Math]{[myStartDate]}+{[math][occurences]-1[/math]/00/0000}[/Math][/text]
		[/then]
		[else]
			[text]myEndDate=[Math]{[myStartDate]}+{00/[math][occurences]-1[/math]/0000}[/Math][/text]
		[/else]
		[/if]
		[!]myEnd month=[format Days_To_Date %m/%d/%Y][myEndDate][/format] [myEndDate]<br>[/!]
		
		[!]do it again if we are net getting a specific numeric day of the month but a weekday like a tuesday[/!]
		[hideif [myWeekday]=DayOfMonth]
			[text]myMonth=[format Days_To_Date %m][myEndDate][/format][/text]
			[text]myYear=[format Days_To_Date %Y][myEndDate][/format][/text]
			[!]month=[myMonth]&year=[myYear]&ordinal=[myOrdinal]&day=[myWeekday]<br>[/!]
			[!]get the exact date of our last occurence[/!]
			[text]myEndDate=[getDayOccurrenceDate month=[myMonth]&year=[myYear]&ordinal=[myOrdinal]&day=[myWeekdayNumber]][/text]
		[/hideif]
		[if ("[myWeekday]"="DayOfMonth")&("[myOrdinal]"="5")][then]
			[text]myMonth=[format Days_To_Date %m][myEndDate][/format][/text]
			[text]myYear=[format Days_To_Date %Y][myEndDate][/format][/text]
			[if "[date_format]"="mdy"][then]
				[text]myEndDate=[Math]{[myMonth]/[getDayCount month=[myMonth]&year=[myyear]]/[myYear]}[/math][/text]
			[/then]
			[else]
				[text]myEndDate=[Math]{[getDayCount month=[myMonth]&year=[myyear]]/[myMonth]/[myYear]}[/math][/text]
			[/else]
			[/if]
		[/then]
		[/if]
		myEndDate=[format Days_To_Date][myEndDate][/format]
	[/showif]
	[!]------------------------yearly--------------------------------------[/!]	
	[!]yearly_day_1_monday_march[/!]
	[showif [recurrenceString]^yearly_day]
		[!]convert stringdate to days[/!]

		[text]myYear=[format Days_To_Date %Y][math]{[startdate]}[/math][/format][/text]
		[text]myOrdinal=[getchars start=12&end=12][recurrenceString][/getchars][/text]
		[text]myWeekday=[middle startafter=[myOrdinal]_&endbefore=_][recurrenceString][/middle][/text]
		[text]myMonth=[middle startafter=[myWeekday]_&endbefore=_][recurrenceString][/middle][/text]
		
		[text]myWeekdayNumber=[getDayOfWeekFromWeekday weekday=[myWeekday]][/text]
		
		[text]myMonthNumber=[getMonthNumber monthName=[myMonth]][/text]
		[!]myMonthNumber:[myMonthNumber]<br>[/!]
		
		[!]any weekday of the month based only on the ordinal[/!]
		[showif [myWeekday]=DayOfMonth]
			[if "[date_format]"="mdy"][then]
				[text]myStartDate=[myMonthNumber]/[showif [myOrdinal]=5][getDayCount month=[myMonthNumber]&year=[myyear]][/showif][showif [myOrdinal]!5][myOrdinal][/showif]/[myYear][/text]
			[/then]
			[else]
				[text]myStartDate=[showif [myOrdinal]=5][getDayCount month=[myMonthNumber]&year=[myyear]][/showif][showif [myOrdinal]!5][myOrdinal][/showif]/[myMonthNumber]/[myYear][/text]
			[/else]
			[/if]
		[/showif]
		[!]regular weekday[/!]
		[showif [myWeekday]!DayOfMonth]
			[text]myStartDate=[format Days_To_Date][getDayOccurrenceDate month=[myMonthNumber]&year=[myYear]&ordinal=[myOrdinal]&day=[myWeekdayNumber]][/format][/text]
		[/showif]
		
		myStartDate=[myStartDate]<br>
		
		[text]myEndDate=[Math]{[myStartDate]}+{00/00/0[Format thousands .3d][math][occurences]-1[/math])[/format]}[/Math][/text]
		myEndDate=[format Days_To_Date][myEndDate][/format]
	[/showif]

	
	[!]yearly_date_01-march[/!]
	[showif [recurrenceString]^yearly_date]
		StartDate=[StartDate]<br>
		
		[text]myDay=[middle startafter=yearly_date_&endbefore=-][recurrenceString][/middle][/text]
		[text]myMonth=[getMonthNumber monthName=[middle startafter=yearly_date_[myDay]-][recurrenceString][/middle]][/text]
		[text]myYear=[format Days_To_Date %Y][math]{[startdate]}[/math][/format][/text]

		[if "[date_format]"="mdy"][then]
			[text]myStartDate=[myMonth]/[myDay]/[myYear][/text]
		[/then]
		[else]
			[text]myStartDate=[myDay]/[myMonth]/[myYear][/text]
		[/else]
		[/if]
		[!]myStartDate=[myStartDate][/!]
		[text]myEndDate=[Math]{[myStartDate]}+{00/00/0[Format thousands .3d][math][occurences]-1[/math][/format]}[/Math][/text]
		myEndDate=[format Days_To_Date][myEndDate][/format]
	[/showif]
	
	[return][myEndDate][/return]
[/function]
[!]--- TEST SECTION ---[/!]
[!]
getWeekInMonthForDate(3/17/2004): 		[getWeekInMonthForDate theDate=3/17/2004]<br>
getDayCount(2, 2004):						[getDayCount month=2&year=2004]<br>
getWeekCount(5, 2004):						[getWeekCount month=5&year=2004]<br>
getDayOccurenceDate(11, 2004, 4, 4):	[math date][getDayOccurrenceDate month=11&year=2004&ordinal=4&day=4][/math]
[/!]

[!][getEndDate startdate=732037&occurences=3&recurrenceString=monthly_date_15][/!]
<p>
[!]04/15/2004 + 2 months:[Math date]{04/15/2004}+{02/00/0000}[/Math] <br>
[format Days_To_Date %m/%d/%Y]732051[/format] + 2 months:[Math date]732051+{02/00/0000}[/Math]<br>
[math date]732051[/math]
[/!]

[!]works<br>weekly_thursday_friday:[getEndDate startdate=4/1/2004&occurences=7&recurrenceString=weekly_thursday_friday_saturday]<br>[/!]
[!]worksweekly_thursday_friday:[getEndDate startdate=4/2/2004&occurences=8&recurrenceString=weekly_wednesday_friday]<br>[/!]
[!]works monthly_date_15: [getEndDate startdate=3/1/2004&occurences=3&recurrenceString=monthly_date_15]<br>[/!]
[!]works[getEndDate startdate=3/22/2004&occurences=3&recurrenceString=monthly_day_4_Monday][/!]
[!]works[getEndDate startdate=3/1/2004&occurences=3&recurrenceString=yearly_date_01-march][/!]
[!]works[getEndDate startdate=3/1/2004&occurences=2&recurrenceString=yearly_day_1_monday_march][/!]
[!][getEndDate startdate=6/1/2004&occurences=2&recurrenceString=monthly_day_5_DayOfMonth][/!]
[!]
add 2month:[math date]{6/30/2004}+{2/00/0000}[/math]<br>
add 2year:[math date]{7/31/2004}+{0/00/0002}[/math]
[/!]