<!--HAS_WEBDNA_TAGS-->
[include file=../header.inc&top=T&page_title=params_string]
<p>
If your function code acts on only one parameter, you can simplify the function call
by using the [raw][params_string][/raw] tag in your function definition.  This tag evaluates to the parameters
string that was used when calling the function. So in cases when you require only one parameter to your function, you
can use [raw][params_string][/raw] to eliminate the need to 'name' the parameter.
<p>
Here is an example...
<b>
[raw]
<xmp>
[function name=Backwards]
[text]length=[countchars][params_string][/countchars][/text]
[loop start=[length]&end=1&advance=-1][getchars start=[index]&end=[index]][params_string][/getchars][/loop]
[/function]
</xmp>
[/raw]
</b>
Note that we used the [raw][params_string][/raw], in place of the 'instring' variable used in the
previous example.
<p>
Now the execution of the function is simply...
<b>
[raw]
<xmp>
[Backwards abcdef_12345]
</xmp>
[/raw]
</b>
<p>
And the result is...
<hr>
[function name=Backwards]
[text]length=[countchars][params_string][/countchars][/text]
[loop start=[length]&end=1&advance=-1][getchars start=[index]&end=[index]][params_string][/getchars][/loop]
[/function]

[Backwards abcdef_12345]

[include file=../header.inc&top=F&page_title=params_string]