<!--HAS_WEBDNA_TAGS-->
[include file=../header.inc&top=T&page_title=Example 'Pass by Reference']
<p>
So where is the 'return' value?  As is often the case with WebDNA, by default, the functions 'return'
value is simply the text that results from the function code itself.  There is a new <b>[raw][return][/raw]</b> context that is 
available inside a WebDNA function, that allows the programmer to 'control' what text is returned from the function call.
You can view the <b>[raw][return][/raw]</b> tutorial <a href="../Return_Context/Return_Context_-_---1---.tpl"><b>here</b></a>, for more details.
<p>
You can assign the results of a function to a variable:
[raw]
<xmp>
[text]results=[Backwards 123abc][/text]
</xmp>
[/raw]
Or, you can simulate a 'pass by reference' by passing the variable name, to receive the results, into the function call.  Here is an example...
<b>
[raw]
<xmp>
[function name=Backwards]
[text]length=[countchars][in_string][/countchars][/text]
[text scope=global][output_to]=[loop start=[length]&end=1&advance=-1][getchars start=[index]&end=[index]][in_string][/getchars][/loop][/text]
[/function]

[Backwards in_string=abcdef_12345&output_to=result]

result = [result]
</xmp>
[/raw]
</b>
Results...
<hr>
[function name=Backwards]
[text]length=[countchars][in_string][/countchars][/text]
[text scope=global][output_to]=[loop start=[length]&end=1&advance=-1][getchars start=[index]&end=[index]][in_string][/getchars][/loop][/text]
[/function]

[Backwards in_string=abcdef_12345&output_to=result]

result = [result]
<hr>
<p>
Again we use explicit scoping to update/create a text variable called 'result', in the templates
global variable name space.  By default, text variables created within a function are local to that function, and are
destroyed when the function call ends.  More on 'local' variable space on the next page.

[include file=../header.inc&top=F&page_title=Example 'Pass by Reference']