<!--HAS_WEBDNA_TAGS-->
[include file=../header.inc&top=T&page_title=SQLExecute]
[include file=javascript.inc&source=example2.inc]
<p>
The <b>[raw][SQLExecute][/raw]</b> context is used to execute all manner of native SQL commands 
and to create result sets from SQL queries ("select" statements).<br>
<br>
In this portion of the tutorial, we will execute a simple "select" SQL statement against our "SMSITest" sample database.<br>
<br>
For example, click "Go" to execute the following:<br>
<i>Please note that the </i>'[raw][Text]bSuccess=T[/Text][/raw]' <i> is not required, and is only there to be used by this tutrial template.</i>
<div id="div_exSQLExecute_Source" style="visibility: visible;" width="100%">
	<table cellpadding="0" cellspacing="0" border="0" width="100%">
		<tr><td><iframe id="ifr_exSQLExecute_Source" border="0" frameborder="0" width="100%" height="250" style="visibility: visible;" src="display_source.tpl?source=example2.inc"></iframe></td></tr>
		<tr><td>&nbsp;</td></tr>
		<tr><td align="right"><input type="button" value="Go" onClick="exSQLExecute();"></td></tr>
	</table>
</div>
<br>
<br>
<div id="div_exSQLExecute" style="visibility: hidden;" width="100%">
	<table cellpadding="0" cellspacing="0" border="0" width="100%">
		<tr><a name="result"></a><td>RESULT:</td></tr>
		<tr><td><iframe id="ifr_exSQLExecute" border="0" frameborder="0" width="100%" style="visibility: hidden;" src=""></iframe></td>
	</table>
</div><br>
<br>
<div id="div_SQLResultDoc" style="visibility: hidden;"">
We see that we successfully connected to the database but why don't we see any results 
from the select statement?  There ARE records in the "employees" table - fifteen of them, in fact. 
However, in order to view results we must make use of the <b>[raw][SQLResult][/raw]</b> 
context, explained in the next section.  For now, let's examine the details of the <b>[raw][SQLExecute][/raw]</b> code above<br>
<br>
<b>[raw][SQLExecute][/raw]</b> allows for two parameters:<br>
- <b>conn_ref</b> or simply <b>ref</b> is <i>required</i> and is the name of the connection variable you created with a prior execution of <b>[raw][SQLConnect][/raw]</b> (the value you set for the "conn_var" or "var" parameter)<br>
- <b>result_var</b> or simply <b>var</b> is <i>optional</i> and the value should be 
the name of the SQLResult variable you wish to create on successful execution. 
This 'result' variable can be used later by setting the "result_ref" (or "ref") 
parameter of <b>[raw][SQLResult][/raw]</b> to this value.  If you do not specify a 
variable name, none will be created and it is assumed you wish to execute non-Select 
SQL commands.  Even if you do execute a non-Select command, you may still want to 
'save' the result.  For example, if you execute a delete command, you can still specify 
a result variable, so that you can access other information, such as the number of rows affected.
<br>
<br>
<b>[raw][SQLExecute][/raw]</b> expects its content to resolve or evaluate to a single SQL command of some sort.  You can place WebDNA here if you wish but <b>[raw][SQLExecute][/raw]</b> will 
fail if its contents are not limited to a valid SQL statement after the inner parse is complete.  Refer to the documentation of your particular SQL server software to determine what a "valid" SQL statement is.  Please note 
that, unlike <b>[raw][SQLConnect][/raw]</b>, you cannot test for successful execution by merely setting a WebDNA text variable within the <b>[raw][SQLExecute][/raw]</b> context since the result of the execution is not 
determined until after its content has been parsed and the statement has been sent to the database server for execution.  However, if <b>[raw][SQLExecute][/raw]</b> fails for any reason, it will output the error directly.<br>
<br>
Click Next to move on the next part of the SQL Contexts tutorial...
</div>

[include file=../header.inc&top=F&page_title=SQLExecute]