<!--HAS_WEBDNA_TAGS-->
[include file=../header.inc&top=T&page_title=Reserved Scope Names]
<p>
There are a few 'reserved' scope names:
<p>
<b>'global'</b> - refers to the 'normal/secure' template variable space.
<p>
<b>'local'</b> - When used inside of a function or scope context, refers to the variable space associated with the current function or scope.
<p>
<b>'insecure'</b> - Refers to the 'insecure' template variable space (this space also includes HTML form variables).
<p>
A demonstration of named and step-wise scope resolution...
[raw]
<b>
<xmp>
[text]abc=123_global[/text]
[text insecure=F]abc=123_insecure[/text]

[scope name=scope1]
[text]abc=123_local[/text]

global 'abc' = [:global:abc] - using reserved 'global' name<br>
global 'abc' = [::abc] - using 'step-wise' scope<br>
<br>
insecure 'abc' = [:insecure:abc] - using reserved 'insecure' name<br>
insecure 'abc'= [::::abc] - using 'step-wise' scope<br>
<br>
local 'abc' = [:local:abc] - using reserved 'local' name<br>
local 'abc' = [abc] - using implied scope<br>
local 'abc' = [:named-scope1:abc] - using 'named' scope<br>

[/scope]
</xmp>
</b>
[/raw]
Results...
<hr>
[text]abc=123_global[/text]
[text secure=F]abc=123_insecure[/text]

[scope name=scope1]
[text]abc=123_local[/text]

global 'abc' = [:global:abc] - using reserved 'global' name<br>
global 'abc' = [::abc] - using 'step-wise' scope<br>
<br>
insecure 'abc' = [:insecure:abc] - using reserved 'insecure' name<br>
insecure 'abc'= [::::abc] - using 'step-wise' scope<br>
<br>
local 'abc' = [:local:abc] - using reserved 'local' name<br>
local 'abc' = [abc] - using implied scope<br>
local 'abc' = [:named-scope1:abc] - using 'named' scope<br>

[/scope]
<hr>
[include file=../header.inc&top=F&page_title=Reserved Scope Names]