<!--HAS_WEBDNA_TAGS-->
[include file=../header.inc&top=T&page_title=Example with ListFiles]

<p>
Tables are also very useful for sorting/searching the results of other 'iterative' WebDNA contexts.
For example, lets sort the results of a [raw][listfiles][/raw] context...
<b>
[raw]
<xmp>
[table name=filesort&fields=filename,size,date][!]
[/!][listfiles path=.]
[filename]	[size]	[createdate]
[/listfiles][/table]

Directory listing - sorted by filename<br>
[search table=filesort&neFILENAMEdata=[blank]&asFILENAMEsort=1]
[founditems]
[filename] - [size] - [date]<br>
[/founditems]
[/search]
<p>
Directory listing - sorted by file size<br>
[search table=filesort&neFILENAMEdata=[blank]&asSIZEsort=1&SIZEtype=num]
[founditems]
[filename] - [size] - [date]<br>
[/founditems]
[/search]
</xmp>
[/raw]
</b>
Results...
<hr>
[table name=filesort&fields=filename,size,date][!]
[/!][listfiles path=.]
[filename]	[size]	[createdate]
[/listfiles][/table]

Directory listing - sorted by filename<br>
[search table=filesort&neFILENAMEdata=[blank]&asFILENAMEsort=1]
[founditems]
[filename] - [size] - [date]<br>
[/founditems]
[/search]
<p>
Directory listing - sorted by file size<br>
[search table=filesort&neFILENAMEdata=[blank]&asSIZEsort=1&SIZEtype=num]
[founditems]
[filename] - [size] - [date]<br>
[/founditems]
[/search]
<hr>
Note that we had to comment out some line endings.  This is because the WebDNA that is parsed between the 
[raw][table][/raw] tags must evaluate to a list of 'records', with the 'fields' delimited by tabs and each
'record' ending with a line ending ([convertchars]<cr><lf> or <lf> or <cr>[/convertchars]).  In other words, exactly the same format as a 
WebDNA database.
<p>
Lets combine this with a webdna [raw][function][/raw] context to list all files in a folder, and its sub-folders.
<br>
<small> 
The new WebDNA [raw][function][/raw] context is described in the 'Function Context' tutorial.
</small>
<p>
Here is the code...
<b>
[raw]
<xmp>
[function name=get_files]
[listfiles path=[in_path]]
   [!]IF this is a folder, recurse into the folder[/!]
[showif [IsFolder]=T]
[return][depth]	<b>[filename]</b>	T
[get_files root=F&in_path=[hideif [root]=TT][in_path]/[/hideif][filename]&depth=[math][depth]+1[/math]][/return]
[/showif]

[hideif [IsFolder]=T]
[return][depth]	[filename]	F
[/return][/hideif]
[/listfiles][/function]

[table name=file_tree_table&fields=depth,name,isfolder]
[get_files root=T&in_path=../../../user_files&depth=0]
[/table]

Display the folder tree of the 'user_files' folder.<br>
[search table=file_tree_table&eqISFOLDERdata=T&rank=off]
[founditems]
[loop start=0&end=[depth]]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[/loop][name]<br>
[/founditems]
[/search]
<p>
Display the complete file tree of the 'user_files' folder<br>
[search table=file_tree_table&neNAMEdata=B&rank=off]
[founditems]
[loop start=0&end=[depth]]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[/loop][name]<br>
[/founditems]
[/search]
</xmp>
[/raw]
</b>
Results...
<hr>
[function name=get_files]
[listfiles path=[in_path]]
   [!]IF this is a folder, recurse into the folder[/!]
[showif [IsFolder]=T]
[return][depth]	<b>[filename]</b>	T
[get_files root=F&in_path=[hideif [root]=TT][in_path]/[/hideif][filename]&depth=[math][depth]+1[/math]][/return]
[/showif]

[hideif [IsFolder]=T]
[return][depth]	[filename]	F
[/return][/hideif]
[/listfiles][/function]

[table name=file_tree_table&fields=depth,name,isfolder]
[get_files root=T&in_path=../../../user_files&depth=0]
[/table]

Display the folder tree of the 'user_files' folder.<br>
[search table=file_tree_table&eqISFOLDERdata=T&rank=off]
[founditems]
[loop start=0&end=[depth]]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[/loop][name]<br>
[/founditems]
[/search]
<p>
Display the complete file tree of the 'user_files' folder<br>
[search table=file_tree_table&neNAMEdata=B&rank=off]
[founditems]
[loop start=0&end=[depth]]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[/loop][name]<br>
[/founditems]
[/search]
<hr>
In the example above, we used a single table to store all the folder and file info.  We could have created a separate table for each folder,
which would provide more flexibility for sorting the folders and files (which is what we did to create the 'file tree' popup window used in this lab application.).

[include file=../header.inc&top=F&page_title=Example with ConvertChars III]