<!--HAS_WEBDNA_TAGS-->
[include file=../header.inc&top=T&page_title=Example 1]
<p>
Okay, so lets get our hands dirty!  Lets use the previous XSL example
to compile XSL code and then apply it to an XML document...
<p>
Example - Select all the 'CD' nodes in the example1.xml XML document
and transform the results into an HTML table, with the 'text' data
of each CD node tree displayed in the table rows.
<p>
Here is the code...
<b>
[raw]
<xmp>
[xsl var=xsl_var1]
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="/">
  <html>
  <body>
    <h2>My CD Collection</h2>
    <table border="1">
      <tr bgcolor="#9acd32">
        <th>Title</th>
        <th>Artist</th>
      </tr>
      <xsl:for-each select="CATALOG/CD">
      <tr>
        <td><xsl:value-of select="TITLE"/></td>
        <td><xsl:value-of select="ARTIST"/></td>
      </tr>
      </xsl:for-each>
    </table>
  </body>
  </html>
</xsl:template>
</xsl:stylesheet>
[/xsl]

[xslt xslref=xsl_var1][include file=example1.xml][/xslt]
</xmp>
[/raw]
</b>
Results...
<hr>
[xsl var=xsl_var1]
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="/">
  <html>
  <body>
    <h2>My CD Collection</h2>
    <table border="1">
      <tr bgcolor="#9acd32">
        <th>Title</th>
        <th>Artist</th>
      </tr>
      <xsl:for-each select="CATALOG/CD">
      <tr>
        <td><xsl:value-of select="TITLE"/></td>
        <td><xsl:value-of select="ARTIST"/></td>
      </tr>
      </xsl:for-each>
    </table>
  </body>
  </html>
</xsl:template>
</xsl:stylesheet>
[/xsl]

[xslt xslref=xsl_var1][include file=example1.xml][/xslt]
<hr>
This is a pretty simple table, but it should give you an idea of what you can
do with XSL(T).
<p>
Here is the same example, but without using the XSL context to pre-compile
the in-line XSL code.  Instead, a URL reference is made to an external xsl file, which happens to 
match the XSL code block above.  It also uses the 'xmlsource' parameter to reference an external xml file to transform.
<p>
Here is the source...
<b>
[raw]
<xmp>
[!] build the URL path to this lab folder [/!]
[text]host=[listmimeheaders name=HOST&exact=F][value][/listmimeheaders][/text]
[text]path=[url][listpath pathonly=T&path=[thisurl]][name]/[/listpath][/url][/text]

[xslt xslsource=http://[host]/[path]example1.xsl&xmlsource=http://[host]/[path]example1.xml][/xslt]
</xmp>
[/raw]
</b>
Results (should be the same as above)...
<hr>
[!] build the URL to this lab folder [/!]
[text]host=[listmimeheaders name=HOST&exact=F][value][/listmimeheaders][/text]
[text]path=[url][listpath pathonly=T&path=[thisurl]][name]/[/listpath][/url][/text]

[xslt xslsource=http://[host]/[path]example1.xsl&xmlsource=http://[host]/[path]example1.xml][/xslt]

[include file=../header.inc&top=F&page_title=Example 1]

