[!]
	Copyright 1998-2000 Smith Micro Software
[/!]

[ExclusiveLock db=WebMerchantPrefs.db&db=Orders.db]
	[text]ordersFolder=../[lookup db=SandBoxPrefs&lookInField=preference&value=OrdersFolder&returnField=value][/text]
	[text]completedFolder=../[lookup db=SandBoxPrefs&lookInField=preference&value=CompletedFolder&returnField=value][/text]
	[text]problemsFolder=../[lookup db=SandBoxPrefs&lookInField=preference&value=ProblemsFolder&returnField=value][/text]
	[text]pendingFolder=../[lookup db=WebMerchantPrefs.db&lookInField=preference&value=PendingFolder&returnField=value][/text]

	[text]emailFrom=[lookup db=WebMerchantPrefs.db&lookInField=preference&value=EMailFrom&returnField=value][/text]
	[text]NotifyPurchases=[lookup db=WebMerchantPrefs.db&lookInField=preference&value=NotifyPurchases&returnField=value][/text]
	[text]NotifyProblems=[lookup db=WebMerchantPrefs.db&lookInField=preference&value=NotifyProblems&returnField=value][/text]
	[text]NotifyOrders=[lookup db=WebMerchantPrefs.db&lookInField=preference&value=NotifyOrders&returnField=value][/text]
	[text]AdminEmail=[lookup db=WebMerchantPrefs.db&lookInField=preference&value=AdminEmail&returnField=value][/text]
	[text]CreditCardProcessor=[lookup db=WebMerchantPrefs.db&lookInField=preference&value=CreditCardProcessor&returnField=value][/text]
	[text]ErrorLog=[lookup db=WebMerchantPrefs.db&lookInField=preference&value=ErrorLog&returnField=value][/text]
	[text]today=[date][/text]
	[text]now=[time][/text]

	[math show=f]numFiles=0;firstIndex=1;hitFirstIndex=0[/math]
	[ListFiles [ordersFolder]]
		[ShowIf [hitFirstIndex]=0][math show=f]hitFirstIndex=1;firstIndex=[index][/math][/ShowIf]
		[text]fileArray[index]=[filename][/text]
		[math show=f]numFiles=numFiles+1[/math]
	[/ListFiles]
	[math show=f]lastFile=firstIndex+numFiles-1[/math]

	[HideIf [numFiles]>0]
		<h3>There are no order files to process</h3>
	[/HideIf]

	[ShowIf [numFiles]>0]
	[Loop start=[firstIndex]&end=[lastFile]]
		[!] Since this is a loop, we need to clear out any old values from previous iteration [/!]
		[text multi=t]m_cart=&m_payMethod=&m_GrandTotal=&m_tax=&m_email=&m_AccountNum=&m_status=&m_authnum=&m_response=&m_batchnum=&m_refnum=&m_sequencenum=&m_itemnum=&m_AddressResponse=[/text]
		[text]filename=[Interpret][fileArray[index]][/Interpret][/text]
		[ShowIf [ErrorLog]!]
		[AppendFile file=[ErrorLog]][today]	[now]	Opening [filename][UnURL]%0D%0A[/UnURL][/AppendFile]
		[/ShowIf]
		[text]today=[date][/text]
		[text]now=[time][/text]
		[text]stamp=[math]{[date]}[/math].[time %H%M][/text]
		[OrderFile file=[ordersFolder][filename]]
			[!] Watermark account# if we are in DEMO mode [/!]
			[!] Here is where we check to see which processor to use: MacAuthorize, CyberCash, PCAuthorize, ICVerify, AccountAuthorizer
				The name of the *.inc file is [CreditCardProcessor].inc, as in CyberCash.inc
			[/!]
			[!] If the payMethod is AC or PA, then use the hook instead of the normal processor [/!]
			[ShowIf [payMethod]=AC][text]CreditCardProcessor=AccountAuthorizer[/text][/ShowIf]
			[ShowIf [payMethod]=PA][text]CreditCardProcessor=AccountAuthorizer[/text][/ShowIf]
			[hideif [payMethod]^OB] [!]This is not necessary for the out of band processing that has aleady stored the results in the file[/!]
			<b>Processing file [filename] with [CreditCardProcessor]</b><br>
			[ShowIf [ErrorLog]!]
			[!] Check to see if payment processor exists [/!]
			[ShowIf [FileInfo file=^WebMerchant/[CreditCardProcessor].inc][exists][/FileInfo]=F]
			<b>Error! Payment processor [CreditCardProcessor].inc does not exist in Globals/WebMerchant folder</b>
			[AppendFile file=[ErrorLog]][today]	[now]	Error! [CreditCardProcessor].inc does not exist[UnURL]%0D%0A[/UnURL][/AppendFile]
			[/ShowIf]
			[AppendFile file=[ErrorLog]][today]	[now]	Processing [filename] with [CreditCardProcessor][UnURL]%0D%0A[/UnURL][/AppendFile]
			[/ShowIf]
			[/hideif]
			[hideif [payMethod]^OB] [!]This is not necessary for the out of band processing that has aleady stored the results in the file[/!]
			[text multi=t][Include file=^WebMerchant/[CreditCardProcessor].inc&cart=[filename]&AddressVerify=[lookup db=WebMerchantPrefs.db&lookInField=preference&value=AddressVerify&returnField=value]][/text]
			[/hideif]
			[showif [payMethod]^OB] [!]We need to pull the info from the order file[/!]
			[text show=f]m_status=[status][/text]
			[showif [m_status]=][text]m_status=Waiting_[stamp][/text][/showif]
			[text show=f]m_authnum=[AuthNumber][/text]
			[text show=f]m_response=[responseText][/text]
			[text show=f]m_sequencenum=[sequenceNumber][/text]
			[text show=f]m_itemnum=[ItemNumber][/text]
			[text show=f]m_refnum=[referenceNumber][/text]
			[text show=f]m_batchnum=[batchNumber][/text]
			[text show=f]m_AddressResponse=[middle startafter=&endbefore=:][responseText][/middle][/text]
			[/showif]
			[text multi=t]m_cart=[cart]&m_payMethod=[payMethod]&m_GrandTotal=[grandTotal]&m_tax=[taxTotal]&m_email=[email]&m_AccountNum=[AccountNum][/text]
		[/OrderFile]
		[ShowIf [ErrorLog]!]
		[AppendFile file=[ErrorLog]][today]	[now]	status: [m_status], authnum: [m_authnum], response: [m_response], batchnum: [m_batchnum], refnum: [m_refnum], sequencenum: [m_sequencenum], itemnum: [m_itemnum], address_response: [m_AddressResponse][UnURL]%0D%0A[/UnURL][/AppendFile]
		[/ShowIf]
		status: [m_status]<br>
		authnum: [m_authnum]<br>
		response: [m_response]<br>
		batchnum: [m_batchnum]<br>
		refnum: [m_refnum]<br>
		sequencenum: [m_sequencenum]<br>
		itemnum: [m_itemnum]<br>
		address_response: [m_AddressResponse]
		<hr>

		[!] Rewrite the order file with status info that came back from MacAuthorize [/!]
		[SetHeader file=[ordersFolder][filename]]AccountNum=[ConvertChars db=^WebMerchant/NumbersOnly.db][m_AccountNum][/ConvertChars]&Status=[m_status]&AuthNumber=[m_AuthNum]&ResponseText=[URL][m_Response][/URL]&BatchNumber=[m_BatchNum]&ReferenceNumber=[m_RefNum]&SequenceNumber=[m_SequenceNum]&ItemNumber=[m_ItemNum][/SetHeader]

		[text]Action=[/text]
		[ShowIf [m_payMethod]^VO][text]Action=Void[/text][/ShowIf]
		[ShowIf [m_payMethod]^CC][text]Action=Sale[/text][/ShowIf]
		[ShowIf [m_payMethod]^CR][text]Action=Credit[/text][/ShowIf]
		[ShowIf [m_payMethod]=CK][text]Action=Sale[/text][/ShowIf]
		[ShowIf [m_payMethod]=PC][text]Action=Pmt[/text][/ShowIf]
		[ShowIf [m_payMethod]^BK][text]Action=Book[/text][/ShowIf]
		[ShowIf [m_payMethod]^SH][text]Action=Sale[/text][/ShowIf]
		[ShowIf [m_payMethod]=AC][text]Action=Sale[/text][/ShowIf]
		[ShowIf [m_payMethod]=PA][text]Action=Pmt[/text][/ShowIf]
		[!][ShowIf [m_payMethod]=OB][text]Action=Sale[/text][/ShowIf][/!]

		[!] If none of the above lines executed, then we have an invalid payMethod, so send an email and move to Problems [/!]
		[ShowIf [Action]=]
			[text multi=T]Action=????&m_status=????[/text]
			[SendMail to=[AdminEmail]&from=[emailFrom]&subject=Invalid payMethod in Order File [filename]]Order file [cart] did not have a payMethod of CC, CR, PC, BK, SH, or VO.  Moving to [problemsFolder][/SendMail]
		[/ShowIf]

		[!] Move good orders to Completed folder [/!]
		[ShowIf [m_status]=Approved]
			[OrderFile file=[ordersFolder][filename]]
				[!] Write the log [/!]
				[include file=GoodPath.inc&cart=[filename]&StoreID=[StoreID]]
				[Include file=^WebMerchant/OrderSplit.inc&cart=[filename]&AddressResponse=[m_AddressResponse]&Action=[Action]]
			[/OrderFile]
			[ShowIf [ErrorLog]!]
			[AppendFile file=[ErrorLog]][today]	[now]	Order was good, sending email to [NotifyPurchases], [NotifyOrders]. Moving to [completedFolder][UnURL]%0D%0A[/UnURL][/AppendFile]
			[/ShowIf]
			[ShowIf [m_payMethod]^CC][MoveFile from=[ordersFolder][filename]&to=[completedFolder][filename]][/ShowIf]
			[ShowIf [m_payMethod]^CR][MoveFile from=[ordersFolder][filename]&to=[completedFolder][filename]][/ShowIf]
			[ShowIf [m_payMethod]=CK][MoveFile from=[ordersFolder][filename]&to=[completedFolder][filename]][/ShowIf]
			[ShowIf [m_payMethod]=PC][MoveFile from=[ordersFolder][filename]&to=[completedFolder][filename]][/ShowIf]
			[ShowIf [m_payMethod]=AC][MoveFile from=[ordersFolder][filename]&to=[completedFolder][filename]][/ShowIf]
			[ShowIf [m_payMethod]=PA][MoveFile from=[ordersFolder][filename]&to=[completedFolder][filename]][/ShowIf]
			[!][ShowIf [m_payMethod]=OB][MoveFile from=[ordersFolder][filename]&to=[completedFolder][filename]][/ShowIf][/!]
			[ShowIf [m_payMethod]^VO][MoveFile from=[ordersFolder][filename]&to=[completedFolder][filename]][/ShowIf]
			[ShowIf [m_payMethod]^BK][MoveFile from=[ordersFolder][filename]&to=[pendingFolder][filename]][/ShowIf]
			[ShowIf [m_payMethod]^SH][MoveFile from=[ordersFolder][filename]&to=[completedFolder][filename]][/ShowIf]
		[/ShowIf]

		[!] Move pending orders to Pending folder [/!]
		[ShowIf [m_status]=Pending]
			[OrderFile file=[ordersFolder][filename]]
				[!] Write the log [/!]
				[include file=PendingPath.inc&cart=[filename]&StoreID=[StoreID]]
				[Include file=^WebMerchant/OrderSplit.inc&cart=[filename]&AddressResponse=[m_AddressResponse]&Action=[Action]]
			[/OrderFile]
			[ShowIf [ErrorLog]!]
			[AppendFile file=[ErrorLog]][today]	[now]	Get Pending message, sending email to [AdminEmail].  Moving to [pendingFolder][UnURL]%0D%0A[/UnURL][/AppendFile]
			[/ShowIf]
			[MoveFile from=[ordersFolder][filename]&to=[pendingFolder][filename]]
		[/ShowIf]

		[!] Move bad orders to Problems folder [/!]
		[math show=F]wasProblem=1[/math]
		[ShowIf [m_status]=Approved][math]wasProblem=0[/math][/ShowIf]
		[ShowIf [m_status]=Pending][math]wasProblem=0[/math][/ShowIf]
		[!] We don't want a Communication Problem like ICVerify not answering to cause files to be dumped to Problems folder...they should retry forever [/!]
		[ShowIf [m_status]=Communications Problem][math show=f]wasProblem=0[/math][/ShowIf]
		[ShowIf [m_status]^Waiting_]
			[math show=F]wasProblem=0[/math]
			[showif [math show=T][stamp]-[getchars start=9&end=][m_status][/getchars][/math]>.0010]
			[math show=F]wasProblem=1[/math]
			[/showif]
		[/ShowIf]
		[ShowIf [wasProblem]=1]
			[OrderFile file=[ordersFolder][filename]]
				[!] Write the log [/!]
				[include file=BadPath.inc&cart=[filename]&StoreID=[StoreID]]
				[Include file=^WebMerchant/OrderSplit.inc&cart=[filename]&AddressResponse=[m_AddressResponse]&Action=[Action]]
			[/OrderFile]
			[ShowIf [ErrorLog]!]
			[AppendFile file=[ErrorLog]][today]	[now]	Order was bad, sending email to [NotifyProblems].  Moving to [problemsFolder][UnURL]%0D%0A[/UnURL][/AppendFile]
			[/ShowIf]
			[MoveFile from=[ordersFolder][filename]&to=[problemsFolder][filename]]
		[/ShowIf]
	[/Loop]
	[/ShowIf]
[/ExclusiveLock]
