[!]
	This template can be used to control how the WebDNA parser evaluates the [cart] tag
	It is important that the WebDNA code in this file evaluates to a single string
	of numeric characters, that does not exceed 32 characters in length.  Be sure to 
	comment all whitespace.
	
	To enable this tempalte, set the "Cart Mode" to 'Use cart_hook.inc'
	in your WebDNA 'General' preferences admin
	
	For this include file:
	[WebDNA_cart_num] is a reserved tag that evaluates to a unique string of numbers generated by the WebDNA parser.
	[WebDNA_cart_fetch] is a reserved tag that evaluates to 'T' when the WebDNA parser is fetching a cart value.
	
	Note: Most of the time, the WebDNA parser will call this template with the 'WebDNA_cart_fetch' value set to 'T'.
	This happens when the parser encounters a [cart] tag, or is processing one of the e-Commerce commands (Add, Clear, Remove, Showcart, and Purchase),
	and the parser needs to 'retrieve' a cart value.
	
	After a successfull purchase action (via the [purchase] tag or 'purchase' command), the WebDNA parser will call this template with
	the 'WebDNA_cart_fetch' value set to 'F'.  This provides an opportunity for the WebDNA programmer to 
	handle the 'clearing' of the cart value.
	
[/!][middle startafter=<_CART_BEGIN_>&endbefore=<_CART_END_>] [!] used to remove white space from the template results [/!]

[text]cartCookieName=WEBDNA_CART[/text]
[text]cartCookieValue=[/text]

[!] Are we fetching a cart number? [/!]
[showif [WebDNA_cart_fetch]=T]

	[!] lookup 'cart' cookie [/!]
	[text]cartCookieValue=[getCookie name=[cartCookieName]][/text]

	[!] lookup 'cart' formvariable * [/!]
	[text]_cart=[formvariables name=cart&exact=T][showif [index]=1][value][/showif][/formvariables][/text]
	
	[!] If a cart form variable was not passed in...[/!]
	[showif =[_cart]]
		[!] If we recieved a cart cookie, use it [/!]
		[showif ![cartCookieValue]]
		[text]_cart=[cartCookieValue][/text]
		[/showif]
		
		[!] If we still do not have a cart value then grab a cart number from the WebDNA engine [/!]
		[showif [_cart]=]
		[text]_cart=[WebDNA_cart_num][/text]
		[/showif]
	[/showif]
	
	[!] If needed, send the cart value back to the browser as a new 'session' cookie [/!]
	[showif [_cart]![cartCookieValue]]
		[setCookie name=[cartCookieName]&value=[_cart]&path=/]
	[/showif]
	
	[!] Return the cart value [/!]
	<_CART_BEGIN_>[_cart]<_CART_END_>

[/showif] [!] [WebDNA_cart_fetch]=T [/!]


[!] If we are not fetching a cart value, then we are clearing it [/!]
[showif [WebDNA_cart_fetch]=F]
	[!] Place code here to 'clear' the cart session cookie [/!]
	[setCookie name=[cartCookieName]&value=&path=/]
	
	[!] Note: Depending of the 'structure' of the website, clearing this 'session' cookie here may not 
	          clear all instances of this cart cookie for other sub folders, or sub domains, of the website.
	          But since the WebDNA engine now 'time stamps' cart/order filename at the time of purchase,
	          it is not really necessary to clear the cookie, as it is now possible for the customer to 
	          continue with another purchase using the same cart value.
	[/!]
[/showif]

[/middle][!] make sure there is no whitespace after this point [/!]