# /bin/sh
# Install Pre processing script 2009-02-08 Jaz

if [ "$#" != 3 ]; then
        echo ''
        echo "Usage $0 <HTML_DIR> <ENGINE_DIR> <WWW_USER_NAME>"
        echo ''
        exit 1
fi

PATH=$PATH:./

DATE_RUN=`date "+%Y%m%d_%H%M%S"`
HTML=$1
WWW_USER=$3

ENGINE_DIR=$2
ENGINE_BACKUP_DIR=`dirname ${ENGINE_DIR}`/backup/`basename ${ENGINE_DIR}`_${DATE_RUN}
WEBCATALOG_DIR=${HTML}/WebCatalog
CP=/bin/cp
ECHO=/bin/echo

# stop WebDNA
pid=`pidof WebCatalog WebDNAMonitor WebDNA`

if [ -n "$pid" ]; then
	 kill -2 $pid
	 echo "WebCatalog stopped"
	 sleep 2
fi

#
# Backup all needed database files.
#
echo ${ENGINE_BACKUP_DIR} >/tmp/WebDNA_backup.txt
if [ -d ${ENGINE_DIR} ]; then
   $ECHO " ${ENGINE_DIR} directory exists"
   $ECHO " Backing up directory to ${ENGINE_BACKUP_DIR}"
   mkdir -p `dirname ${ENGINE_BACKUP_DIR}`
   $CP -rp ${ENGINE_DIR} ${ENGINE_BACKUP_DIR}
fi

mkdir -p ${HTML}
mkdir -p ${ENGINE_DIR}/EMailCompleted
mkdir -p ${ENGINE_DIR}/EMailLog
mkdir -p ${ENGINE_DIR}/EMailProblem
mkdir -p ${ENGINE_DIR}/EMailFolder

mkdir -p ${ENGINE_DIR}/SandBoxes/MASTER_SANDBOX/EMailCompleted
mkdir -p ${ENGINE_DIR}/SandBoxes/MASTER_SANDBOX/EMailLog
mkdir -p ${ENGINE_DIR}/SandBoxes/MASTER_SANDBOX/EMailProblem
mkdir -p ${ENGINE_DIR}/SandBoxes/MASTER_SANDBOX/EMailFolder

mkdir -p ${WEBCATALOG_DIR}/CMSBuilder/MASTER_CMS/cms/upload
mkdir -p ${WEBCATALOG_DIR}/WSWizard/data/user

mkdir -p ${WEBCATALOG_DIR}/StoreBuilder/MASTER_STORE/Orders
mkdir -p ${WEBCATALOG_DIR}/StoreBuilder/MASTER_STORE/ShoppingCarts
mkdir -p ${WEBCATALOG_DIR}/StoreBuilder/MASTER_STORE/staticpages
mkdir -p ${WEBCATALOG_DIR}/StoreBuilder/MASTER_STORE/WebMerchant/CompletedOrders
mkdir -p ${WEBCATALOG_DIR}/StoreBuilder/MASTER_STORE/WebMerchant/Pending
mkdir -p ${WEBCATALOG_DIR}/StoreBuilder/MASTER_STORE/WebMerchant/Problems
mkdir -p ${WEBCATALOG_DIR}/StoreBuilder/MASTER_STORE/WebMerchant/StockRoom
mkdir -p ${WEBCATALOG_DIR}/StoreBuilder/MASTER_STORE/WebMerchant/WebDelivery
mkdir -p ${WEBCATALOG_DIR}/TeaRoomXML/Orders
mkdir -p ${WEBCATALOG_DIR}/TeaRoomXML/ShoppingCarts
mkdir -p ${WEBCATALOG_DIR}/TeaRoomXML/WebMerchant/CompletedOrders
mkdir -p ${WEBCATALOG_DIR}/TeaRoomXML/WebMerchant/Pending
mkdir -p ${WEBCATALOG_DIR}/TeaRoomXML/WebMerchant/Problems
mkdir -p ${WEBCATALOG_DIR}/TeaRoomXML/WebMerchant/StockRoom
mkdir -p ${WEBCATALOG_DIR}/TeaRoomXML/WebMerchant/WebDelivery

# Change Perms
WWW_GROUP=`groups ${WWW_USER} | awk '{print $3}'`
find ${ENGINE_DIR} ${WEBCATALOG_DIR} -type d -exec chmod 775 {} \; -exec chown ${WWW_USER}:${WWW_GROUP} {} \;

