#!/bin/bash
#
# This script looks for problems with libssl and libcrypto and fixes it.
# On Fedora 10, libssl is named with a version g on the end.

function look_for_file_in_dir {
  #Takes two arguments FILENAME and single dir
  if [ -d $2 ]; then
    if [ -f $2/$1 ]; then
      return 0;
    fi
  fi
  return 1;
}

#Not used
function look_in_dirs_for_file {
  #Takes two arguments FILENAME and dirs
  for i in $@ ; do 
    if [ -d $2 ]; then
      look_for_file_in_dir $1 $i
      if [ $? = 0 ]; then
        #Found it
        RESULT=$i
echo $i
        return 0
      fi
    fi 
  done
  return 1
}

#Make sure there is a libssl.so.0.9.8 and libcrypto.so.0.9.8, and if not try to fix the issue
for LIBS in libssl.so.0.9.8 libcrypto.so.0.9.8 ; do
  for j in z y x w v u t s r q p o n m l k j i h g f e d c b a ; do
    TEST=${LIBS}${j}
#echo "TEST is $TEST";
    for DIR_TO_TEST in /lib64 /lib /usr/lib64 /usr/lib /usr/local/lib64 /usr/local/lib; do
      look_for_file_in_dir ${TEST} ${DIR_TO_TEST}
      if [ $? = 0 ]; then
        RESULT=${DIR_TO_TEST}
        LN_TO_POINT=${RESULT}/${TEST}
        LN_TO_CREATE=${RESULT}/${LIBS}
        echo "Creating Link ${LN_TO_CREATE} to ${LN_TO_POINT} if necessary"
        if [ ! -e ${LN_TO_CREATE} ]; then
          ln -s ${LN_TO_POINT} ${LN_TO_CREATE}
        fi
      fi
    done
  done
done
