#!/bin/bash
#
# This script looks for the first successful command while trying the given arguments.


if [ "$#" -lt 2 ]; then
        echo '' 1>&2
        echo "Usage $0 <COMMAND> <ARG1> <ARG2> ..." 1>&2
        echo '' 1>&2
        exit 1
fi

#Store the arguments in an array
ARGS=("$@")
ELEMENT_COUNT=${#ARGS[@]}

#Start at element 1 to skip the COMMAND ($1)
for (( i=1;i<$ELEMENT_COUNT;i++)); do
  TEST_ITEM=${ARGS[i]}
  if [ '${TEST_ITEM}' != '\,' ]; then
    #echo ${TEST_ITEM} 1>&2
    $1 ${TEST_ITEM} >/dev/null 2>&1
    SUCCESS=$?
    if [ $SUCCESS -eq 0 ]; then
      echo $TEST_ITEM
      exit 0;
    fi
  fi
done

exit 1;